import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/*
 * Component thats moves from right to left
 */


public class MovingCanvas extends JPanel implements ActionListener 
{
 static final int VERY_FAST = 50;
 static final int FAST = 100;
 static final int MEDIUM = 200;
 static final int SLOW  = 300;
 static final int VERYSLOW = 500;
 

 String Msg = null;
 java.util.Vector Msgs = null;

 Font font = new Font("Serif",Font.BOLD,12);
 Color color = Color.blue;

 Dimension size = new Dimension(100,100);

 int x;
 int y;

 int speed = MEDIUM ;
 Timer timer = null;

 public MovingCanvas(String message, Dimension size, int x, int y)
 {
  Msg = message;
  Msgs = new java.util.Vector();

  Msgs.addElement(Msg);

  this.size = size;
  this.x = x;
  this.y = y;
  setSize(size); 
  timer = new Timer(speed,this);
  timer.setInitialDelay(0);
  timer.setCoalesce(true);

 }
 public void addMsg(String message)
 {
  boolean New = true;

  for(int i = 0;i<Msgs.size();i++)
   if(((String)Msgs.elementAt(i)).equals(message))
      New = false;

 if(New)      
   Msgs.addElement(message);
 } 

 public void delMsgs()
 {
  Msgs.removeAllElements();
 }


 void setSpeed(int speed)
 {
 this.speed = speed; 
 }
 
 public void setsize(Dimension newSize)
 {
  size = newSize;
  setSize(size);
 } 

 public void setMsgLocation(int x,int y)
 {
 this.x = x;
 this.y = y;
 }
 
 public void setColor(Color newColor)
 {
  color = newColor;
 }

 public void setFont(Font newFont)
 {
  font = newFont;
 }


 public void actionPerformed(ActionEvent ae)
 {

       char ch;
       ch = Msg.charAt(0);
       Msg = Msg.substring(1,Msg.length());
       Msg += ch;
       repaint();
 

} // end of actionPerformed 


 public void start()
 {
  StringBuffer sb = new StringBuffer();

  for(int i = 0; i< Msgs.size();i++)
   sb.append((String)Msgs.elementAt(i));

   Msg = sb.toString();

   if(!timer.isRunning())  
      timer.start();
 }
 

public void stop()
 {
 if(timer.isRunning())  
  timer.stop(); 
 }



 public void paintComponent(Graphics g)
 {
  super.paintComponent(g);
  g.setColor(color);
  g.setFont(font);
  g.drawString(Msg,x,y);
 }





}  // end of MovingCanvas class
